// ------------------------------ Handling the Site's Events with JavaScript ------------------------------

// A website involves a large number of events. When the user clicks, scrolls, fills out a form, etc., these are
// all events, and the site's behavior upon these events can be programmed using JavaScript.

// Not all events are generated by the user's actions; some occur automatically. For example,
// one of the most common events is "The document is ready" (has been loaded by the browser).

// We can detect the occurrence of these events using Event Listeners.
// For example, the following line will detect when the browser has finished loading the window, and
// when this happens, a function will be executed. This function is referred to as a "Callback function."
window.addEventListener('load', function() {
    console.log('The window has been loaded.');
}); 

// This is equivalent to
window.onload = function() {
    console.log('The window has been loaded 2.');
}

// Note: The window is the global element; even 'document' belongs to 'window.' The window includes the HTML file,
// the JavaScript code, CSS styles, etc.

// We can also detect when the HTML has been loaded using DOMContentLoaded.
document.addEventListener('DOMContentLoaded', function() {
    console.log('The document has been loaded'); // This will be executed as soon as the HTML file has been loaded.
});

// Note that while window.onload (or listening for the load event on the window) will wait for all files,
// including images, stylesheets, etc., DOMContentLoaded will only wait for the HTML content to be loaded.
// This difference is often a question in job interviews.

// Because we do not typically modify the stylesheet or images with our script, it's only necessary to
// wait until the HTML file is loaded. Therefore, we use DOMContentLoaded rather than window.onload.
// This way, the code will be executed sooner.

// We can declare separate functions and include them in the event listeners to keep the code clear.
function printClicked() {
    console.log('Clicked!');
}

window.onclick = printClicked;

// We can also associate events with specific HTML elements
/* const myButton = document.querySelector('.myButton');
myButton.addEventListener('click', sayHello);

function sayHello() {
    console.log('Hello user!');
} */

// If the button is inside a form, the default task for a submit-type input is sending the form's content
// to a file on our server. This file can be specified in the form element in HTML. This is why, clicking
// a submit button that belongs to a form will also refresh the page. This can be changed using preventDefault.

const myButton = document.querySelector('.myButton');
// All event listener callback functions have access to 'event.' This allows us to manipulate the event's behavior.
myButton.addEventListener('click', function (event) { 
    console.log(event);  // This object will provide the event type, target (what we clicked), etc.
    event.preventDefault();
    console.log('Hello user!');
});

// The event is also available for event listeners with this format: window.onclick.

// preventDefault is particularly useful in a scenario where we must validate the form's input data
// and send the form only once we know everything is okay.

// ---------- Keyboard Events ----------
const userName = document.querySelector('#myName');
userName.addEventListener('change', function() {
    console.log('The user has typed their name');
})
// This event listener will only take effect once the value of the text area has changes 
// (then the user clicks out of the area and the value it's different than before).


// We can also act on the user's input as they're writing in real time and get the text
// the user is writing (one letter at the time).
const userMessage = document.querySelector('#myMessage');
userMessage.addEventListener('input', function(event) {
    console.log('The user wrote ',event.target.value); // This will be executed each time a character is written/deleted
})